diff --git a/sql/sql_show.cc b/sql/sql_show.cc
index dbd14ea..5433729 100644
--- a/sql/sql_show.cc
+++ b/sql/sql_show.cc
@@ -2440,7 +2440,8 @@ class thread_info :public ilink {
   uint32 os_thread_id;
   ulonglong start_time;
   uint   command;
-  const char *user,*host,*db,*proc_info,*state_info;
+  const char *user,*host,*db,*proc_info,*state_info, *application_name,
+             *client_user, *client_hostname;
   CSET_STRING query_string;
   double progress;
 };
@@ -2635,6 +2636,32 @@ void mysqld_list_processes(THD *thd,const char *user, bool verbose)
   DBUG_VOID_RETURN;
 }
 
+/**
+  @brief Returns the value of a session variable.
+
+  @param thd           [in]     The handle of the current THD.
+  @param session       [in]     The handle of the session THD.
+  @param variable_name [in]     Name of the variable to search.
+
+  @return                     Pointer to the value buffer or NULL
+*/
+char* get_one_variable_as_char(THD *thd, THD *session, const char *variable_name)
+{
+  user_var_entry *var;
+  LEX_STRING varname;
+  thd->make_lex_string(&varname,variable_name, strlen(variable_name));
+
+  if ((var= get_variable(&session->user_vars, varname, FALSE)))
+  {
+    char tmp[MAX_FIELD_WIDTH];
+    String *tmp_str, str_buff(tmp, sizeof(tmp), system_charset_info);
+    bool null_value;
+    if ((tmp_str= var->val_str(&null_value, &str_buff, 0)))
+      return (char*) thd->memdup(tmp_str->c_ptr_quick(), tmp_str->length() + 1);
+  }
+  return NULL;
+}
+
 
 /*
   Produce EXPLAIN data.
@@ -3029,6 +3056,43 @@ int fill_schema_processlist(THD* thd, TABLE_LIST* tables, COND* cond)
 
       table->field[16]->store(tmp->os_thread_id);
 
+      if (tmp->user_vars.records)
+      {
+        char *value;
+        // APPLICATION_NAME
+        if ((value= get_one_variable_as_char(thd, tmp, "ApplicationName")))
+        {
+          table->field[17]->store(value, strlen(value), cs);
+          table->field[17]->set_notnull();
+        }
+        else
+         table->field[17]->set_null();
+
+        // CLIENT_USER
+        if ((value= get_one_variable_as_char(thd, tmp, "ClientUser")))
+        {
+          table->field[18]->store(value, strlen(value), cs);
+          table->field[18]->set_notnull();
+        }
+        else
+         table->field[18]->set_null();
+
+        // CLIENT_HOSTNAME
+        if ((value= get_one_variable_as_char(thd, tmp, "ClientHostname")))
+        {
+            table->field[19]->store(value, strlen(value), cs);
+            table->field[19]->set_notnull();
+        }
+        else
+         table->field[19]->set_null();
+      }
+      else
+      {
+         table->field[17]->set_null();
+         table->field[18]->set_null();
+         table->field[19]->set_null();
+      }
+
       if (schema_table_store_record(thd, table))
       {
         mysql_mutex_unlock(&LOCK_thread_count);
@@ -8886,6 +8950,12 @@ ST_FIELD_INFO processlist_fields_info[]=
   {"INFO_BINARY", PROCESS_LIST_INFO_WIDTH, MYSQL_TYPE_BLOB, 0, 1,
    "Info_binary", SKIP_OPEN_TABLE},
   {"TID", 4, MYSQL_TYPE_LONGLONG, 0, 0, "Tid", SKIP_OPEN_TABLE},
+  {"APPLICATION_NAME", NAME_CHAR_LEN,  MYSQL_TYPE_STRING, 0, 1,
+   "ApplicationName",SKIP_OPEN_TABLE},
+  {"CLIENT_USER", USERNAME_CHAR_LENGTH,  MYSQL_TYPE_STRING, 0, 1,
+   "ClientUser",SKIP_OPEN_TABLE},
+  {"CLIENT_HOSTNAME", LIST_PROCESS_HOST_LEN,  MYSQL_TYPE_STRING, 0, 1,
+   "ClientHostname",SKIP_OPEN_TABLE},
   {0, 0, MYSQL_TYPE_STRING, 0, 0, 0, SKIP_OPEN_TABLE}
 };
 
diff --git a/sql/sql_show.h b/sql/sql_show.h
index e93b855..c8648f3 100644
--- a/sql/sql_show.h
+++ b/sql/sql_show.h
@@ -137,6 +137,8 @@ const char* get_one_variable(THD *thd, const SHOW_VAR *variable,
                              const CHARSET_INFO **charset, char *buff,
                              size_t *length);
 
+char* get_one_variable_as_char(THD *thd, THD *session, char *variable_name);
+
 /* These functions were under INNODB_COMPATIBILITY_HOOKS */
 int get_quote_char_for_identifier(THD *thd, const char *name, uint length);
 THD *find_thread_by_id(longlong id, bool query_id= false);
-- 
2.6.3.windows.1

